package cn.com.cnarj.control.upload;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import cn.com.cnarj.model.pojo.ComInfo;
import cn.com.cnarj.util.DomParserUtil;
import cn.com.cnarj.util.PropertiesBean;
import cn.com.cnarj.util.PropertiesUtil;
import cn.com.cnarj.view.frame.MainFrame;

/**
 * Ϊÿͷһ߳
 * @author hedan
 * @since 2012-3-14
 *
 */
public class ScoketServer {

	private ExecutorService executorService;// ̳߳
	
	public static UploadSocketClient ss = new UploadSocketClient();
	
	public ScoketServer() {
		
	}
	
	public void receiveThreadStartup()throws Exception{
		try {
			executorService = Executors.newCachedThreadPool(); // ½̳߳
			List<ComInfo> lst_cominfos = getComInfoList();
			if(lst_cominfos != null && lst_cominfos.size() > 0){
				int i = 1;
				Thread thrad = null;
				for(ComInfo cominfo : lst_cominfos){
//					socket = new Socket(cominfo.getRemoteHost(), Integer.valueOf(cominfo.getRemotePort()));
					executorService.execute(new ReceiveThread(cominfo.getRemoteHost(), Integer.valueOf(cominfo.getRemotePort()), i));
//					thrad =  new Thread(new ReceiveThread(cominfo.getRemoteHost(), Integer.valueOf(cominfo.getRemotePort()), i));
//					thrad.start();
					System.out.println("i===="+i);
					i++;
				}
			}
			
		} catch (Exception e) {
			System.out.println("ScoketServer-receiveThreadStartup()-1");
			e.printStackTrace();
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<ComInfo> getComInfoList()throws Exception{
		List<ComInfo> lst_com  = null;
		try {
			List lst = DomParserUtil.readXml("comsconfig.xml");
			if(lst != null && lst.size() > 0){
				int li_rows = lst.size();
				Map map = null;
				ComInfo cominfo = null;
				lst_com = new ArrayList<ComInfo>();
				for(int i = 0; i < li_rows; i++){
					map = new HashMap();
					cominfo = new ComInfo();
					map = (Map)lst.get(i);
					cominfo.setRemoteHost(String.valueOf(map.get("remoteHost")));
					cominfo.setRemotePort(String.valueOf(map.get("remotePort")));
					cominfo.setBswz(String.valueOf(map.get("bswz")));
					lst_com.add(cominfo);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return lst_com;
	}
}
